import SpriteKit
import GameplayKit

class GameScene: SKScene {

	var _bounds:CGRect!
	var _count: Int = 0
	var _nextCount: Int = 60
	var _score = 0
	
	func initialize() {
		_count = 0
		_nextCount = 60
		_score = 0
		self.removeAllChildren()
	}
	
    override func didMove(to view: SKView) {
		_bounds = view.bounds
		self.backgroundColor = UIColor.white
    }
	
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?) {
		if let touch = touches.first as UITouch? {
			let location = touch.location(in: self)
			let label = self.atPoint(location)
			switch label.name {
			case "label"?:
				label.removeFromParent()
				_score += 1
			case "gameOver"?:
				initialize()
			default:
				_score -= 1
			}
		}
    }
    
    override func update(_ currentTime: TimeInterval) {
		let label:SKLabelNode!
		if _nextCount == 0 {
			label = SKLabelNode(text:"SCORE "+String(_score))
			label.position = CGPoint(
				x:Int(_bounds.width/2),
				y:Int(_bounds.height/2))
			label.name = "gameOver"
			label.fontSize = CGFloat(60)
			label.fontColor = UIColor.black
		} else {
			label = SKLabelNode(text:"★")
			label.position = CGPoint(
				x:50+Int(arc4random_uniform(UInt32(_bounds.width-100))),
				y:50+Int(arc4random_uniform(UInt32(_bounds.height-100))))
			label.name = "label"
			label.fontSize = CGFloat(100)
			label.fontColor = UIColor.init(red: 1, green: 0.8, blue: 0, alpha: 1)
		}
		if _count == 0 {
			addChild(label)
			_count = _nextCount
			_nextCount -= 1
		}
		_count -= 1
	}
}
